From b7b1563f0a7b913bac62673b1629755eb2adafc3 Mon Sep 17 00:00:00 2001
From: "Azamat H. Hackimov" <azamat.hackimov@gmail.com>
Date: Sun, 10 Jul 2022 19:53:06 +0300
Subject: [PATCH] Use shared json11 library

Added option -DUSE_SHARED_JSON11
---
 CMakeLists.txt             | 7 +++++++
 third_party/CMakeLists.txt | 4 +++-
 2 files changed, 10 insertions(+), 1 deletion(-)

diff --git a/CMakeLists.txt b/CMakeLists.txt
index 26e09c418..306049917 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -50,6 +50,7 @@ option(USE_SHARED_CMARK   "Use your installed copy of cmark" off)
 option(USE_SHARED_CURL    "Use your installed copy of curl" off)
 option(USE_SHARED_GIFLIB  "Use your installed copy of giflib" off)
 option(USE_SHARED_JPEGLIB "Use your installed copy of jpeglib" off)
+option(USE_SHARED_JSON11  "Use your installed copy of json11" off)
 option(USE_SHARED_ZLIB    "Use your installed copy of zlib" off)
 option(USE_SHARED_LIBARCHIVE "Use your installed copy of libarchive" off)
 option(USE_SHARED_LIBPNG  "Use your installed copy of libpng" off)
@@ -308,6 +309,12 @@ else()
 endif()
 include_directories(${JPEG_INCLUDE_DIRS})
 
+if(USE_SHARED_JSON11)
+  find_package(PkgConfig QUIET)
+  pkg_check_modules(JSON11 json11)
+  include_directories(${JSON11_INCLUDE_DIRS})
+endif()
+
 if(USE_SHARED_CMARK)
   find_library(CMARK_LIBRARIES NAMES cmark)
   find_path(CMARK_INCLUDE_DIRS NAMES cmark.h)
diff --git a/third_party/CMakeLists.txt b/third_party/CMakeLists.txt
index 12017190f..f499545b6 100644
--- a/third_party/CMakeLists.txt
+++ b/third_party/CMakeLists.txt
@@ -123,7 +123,9 @@ if(NOT USE_SHARED_CMARK)
 endif()
 
 # JSON
-add_subdirectory(json11)
+if(NOT USE_SHARED_JSON11)
+  add_subdirectory(json11)
+endif()
 
 # libarchive
 if(NOT USE_SHARED_LIBARCHIVE)
-- 
2.35.1

